
<!doctype html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><title>Python: module bloom</title>
</head><body bgcolor="#f0f0f8">

<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="heading">
<tr bgcolor="#7799ee">
<td valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial">&nbsp;<br><big><big><strong>bloom</strong></big></big></font></td
><td align=right valign=bottom
><font color="#ffffff" face="helvetica, arial"><a href=".">index</a><br><a href="file:./bloom.py">./bloom.py</a></font></td></tr></table>
    <p><tt>Classes&nbsp;and&nbsp;functions&nbsp;for&nbsp;<a href="#Bloom">Bloom</a>&nbsp;filters&nbsp;and&nbsp;derivates.<br>
&nbsp;<br>
Implements&nbsp;the&nbsp;following&nbsp;classes:<br>
<a href="#Bloom">Bloom</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;an&nbsp;abstract&nbsp;class&nbsp;to&nbsp;provide&nbsp;a&nbsp;common&nbsp;<a href="#Bloom">Bloom</a>&nbsp;filter&nbsp;interface<br>
<a href="#BloomFilter">BloomFilter</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;standard&nbsp;<a href="#Bloom">Bloom</a>&nbsp;filter,&nbsp;true/false&nbsp;cells<br>
<a href="#CountingBloomFilter">CountingBloomFilter</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;counting&nbsp;<a href="#Bloom">Bloom</a>&nbsp;filter,&nbsp;uses&nbsp;m&nbsp;counters<br>
<a href="#HuffmanCountingBloomFilter">HuffmanCountingBloomFilter</a>&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;a&nbsp;Huffman&nbsp;compressed&nbsp;counting&nbsp;<a href="#Bloom">Bloom</a>&nbsp;filter<br>
&nbsp;<br>
&nbsp;<br>
Implements&nbsp;an&nbsp;'abstract'&nbsp;empty&nbsp;<a href="#Bloom">Bloom</a>&nbsp;filter&nbsp;object<br>
and&nbsp;different&nbsp;<a href="#Bloom">Bloom</a>&nbsp;filter&nbsp;types.</tt></p>
<p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#ee77aa">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial"><big><strong>Classes</strong></big></font></td></tr>
    
<tr><td bgcolor="#ee77aa"><tt>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</tt></td><td>&nbsp;</td>
<td width="100%"><dl>
<dt><font face="helvetica, arial"><a href="bloom.html#Bloom">Bloom</a>
</font></dt><dd>
<dl>
<dt><font face="helvetica, arial"><a href="bloom.html#BloomFilter">BloomFilter</a>
</font></dt><dt><font face="helvetica, arial"><a href="bloom.html#CountingBloomFilter">CountingBloomFilter</a>
</font></dt><dt><font face="helvetica, arial"><a href="bloom.html#HuffmanCountingBloomFilter">HuffmanCountingBloomFilter</a>
</font></dt></dl>
</dd>
</dl>
 <p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#ffc8d8">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#000000" face="helvetica, arial"><a name="Bloom">class <strong>Bloom</strong></a></font></td></tr>
    
<tr bgcolor="#ffc8d8"><td rowspan=2><tt>&nbsp;&nbsp;&nbsp;</tt></td>
<td colspan=2><tt>Empty&nbsp;bloom&nbsp;filter&nbsp;parent&nbsp;class.<br>
&nbsp;<br>
This&nbsp;class&nbsp;provides&nbsp;a&nbsp;common&nbsp;Interface&nbsp;to&nbsp;<a href="#Bloom">Bloom</a>&nbsp;filters.<br>
It&nbsp;calculates&nbsp;all&nbsp;members&nbsp;depending&nbsp;on&nbsp;parameters&nbsp;and&nbsp;functions.<br>
Members:<br>
_n&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;number&nbsp;of&nbsp;elements<br>
_c&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;number&nbsp;of&nbsp;cells&nbsp;per&nbsp;element<br>
_m&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;number&nbsp;of&nbsp;cells,&nbsp;size<br>
_k&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;number&nbsp;of&nbsp;hash&nbsp;functions<br>
_linear&nbsp;--&nbsp;&nbsp;the&nbsp;function&nbsp;used&nbsp;to&nbsp;calculate&nbsp;_m<br>&nbsp;</tt></td></tr>
<tr><td>&nbsp;</td>
<td width="100%">Methods defined here:<br>
<dl><dt><a name="Bloom-__init__"><strong>__init__</strong></a>(self, n, c, linear<font color="#909090">=True</font>, k<font color="#909090">=0</font>)</dt><dd><tt>Instatiate&nbsp;a&nbsp;bloom&nbsp;object.<br>
&nbsp;<br>
@n&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;number&nbsp;of&nbsp;elements&nbsp;to&nbsp;store<br>
@c&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;number&nbsp;of&nbsp;reserved&nbsp;cells&nbsp;per&nbsp;element<br>
@linear&nbsp;--&nbsp;&nbsp;True&nbsp;if&nbsp;size&nbsp;is&nbsp;computed&nbsp;linear,&nbsp;False&nbsp;if&nbsp;to&nbsp;power&nbsp;2<br>
@k&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;Number&nbsp;of&nbsp;hash&nbsp;functions,&nbsp;if&nbsp;0,&nbsp;optimum&nbsp;is&nbsp;computed</tt></dd></dl>

<dl><dt><a name="Bloom-__len__"><strong>__len__</strong></a>(self)</dt><dd><tt><a href="#Bloom-__len__">__len__</a>()&nbsp;-&gt;&nbsp;self.<strong>_m</strong></tt></dd></dl>

<dl><dt><a name="Bloom-__repr__"><strong>__repr__</strong></a>(self)</dt><dd><tt><a href="#Bloom-__repr__">__repr__</a>()&nbsp;-&gt;&nbsp;string</tt></dd></dl>

<dl><dt><a name="Bloom-clear"><strong>clear</strong></a>(self, *indexes)</dt><dd><tt>Wrapper&nbsp;for&nbsp;clear&nbsp;bits</tt></dd></dl>

<dl><dt><a name="Bloom-dec"><strong>dec</strong></a>(self, *indexes)</dt><dd><tt>Wrapper&nbsp;for&nbsp;decrementing&nbsp;counters</tt></dd></dl>

<dl><dt><a name="Bloom-expecteddist"><strong>expecteddist</strong></a>(self, upper)</dt><dd><tt><a href="#Bloom-expecteddist">expecteddist</a>(upper)&nbsp;-&gt;&nbsp;[int]<br>
&nbsp;<br>
the&nbsp;expected&nbsp;distribution&nbsp;of&nbsp;counter&nbsp;values&nbsp;or&nbsp;insertions</tt></dd></dl>

<dl><dt><a name="Bloom-get"><strong>get</strong></a>(self, *indexes)</dt><dd><tt>Wrapper&nbsp;for&nbsp;get&nbsp;bits</tt></dd></dl>

<dl><dt><a name="Bloom-inc"><strong>inc</strong></a>(self, *indexes)</dt><dd><tt>Wrapper&nbsp;for&nbsp;incrementing&nbsp;counters</tt></dd></dl>

<dl><dt><a name="Bloom-p_0"><strong>p_0</strong></a>(self)</dt><dd><tt><a href="#Bloom-p_0">p_0</a>()&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;any&nbsp;cell&nbsp;has&nbsp;0&nbsp;insertions</tt></dd></dl>

<dl><dt><a name="Bloom-p_countervalue"><strong>p_countervalue</strong></a>(self, i, j)</dt><dd><tt><a href="#Bloom-p_countervalue">p_countervalue</a>(i,j)&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;a&nbsp;counter&nbsp;in&nbsp;a&nbsp;set&nbsp;of&nbsp;j&nbsp;non-empty&nbsp;buckets&nbsp;is&nbsp;j<br>
p(i,j)&nbsp;in&nbsp;fht&nbsp;paper</tt></dd></dl>

<dl><dt><a name="Bloom-p_distinct"><strong>p_distinct</strong></a>(self, j, r)</dt><dd><tt>p_distinct&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;r&nbsp;hashes&nbsp;produce&nbsp;j&nbsp;distinct&nbsp;values</tt></dd></dl>

<dl><dt><a name="Bloom-p_fp"><strong>p_fp</strong></a>(self)</dt><dd><tt><a href="#Bloom-p_fp">p_fp</a>()&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
false&nbsp;positive&nbsp;probability</tt></dd></dl>

<dl><dt><a name="Bloom-p_i"><strong>p_i</strong></a>(self, i)</dt><dd><tt><a href="#Bloom-p_i">p_i</a>(i)&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;any&nbsp;cell&nbsp;has&nbsp;i&nbsp;insertions</tt></dd></dl>

<dl><dt><a name="Bloom-p_linkedlist"><strong>p_linkedlist</strong></a>(self, s)</dt><dd><tt><a href="#Bloom-p_linkedlist">p_linkedlist</a>(s)&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;the&nbsp;smallest&nbsp;value&nbsp;for&nbsp;any&nbsp;k'&lt;=&nbsp;k&nbsp;chosen<br>
cells&nbsp;has&nbsp;value&nbsp;s</tt></dd></dl>

<dl><dt><a name="Bloom-p_smallest"><strong>p_smallest</strong></a>(self, r, s, j)</dt><dd><tt><a href="#Bloom-p_smallest">p_smallest</a>(r,s,j)&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;smallest&nbsp;counter&nbsp;in&nbsp;any&nbsp;r&nbsp;of&nbsp;j&nbsp;buckets&nbsp;is&nbsp;s<br>
q(r,s,j)&nbsp;in&nbsp;fht&nbsp;paper</tt></dd></dl>

<dl><dt><a name="Bloom-set"><strong>set</strong></a>(self, *indexes)</dt><dd><tt>Wrapper&nbsp;for&nbsp;set&nbsp;bits</tt></dd></dl>

<dl><dt><a name="Bloom-size"><strong>size</strong></a>(self)</dt><dd><tt><a href="#Bloom-size">size</a>()&nbsp;-&gt;&nbsp;self.<strong>_m</strong>&nbsp;--&nbsp;same&nbsp;as&nbsp;len(bloom)</tt></dd></dl>

</td></tr></table> <p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#ffc8d8">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#000000" face="helvetica, arial"><a name="BloomFilter">class <strong>BloomFilter</strong></a>(<a href="bloom.html#Bloom">Bloom</a>)</font></td></tr>
    
<tr bgcolor="#ffc8d8"><td rowspan=2><tt>&nbsp;&nbsp;&nbsp;</tt></td>
<td colspan=2><tt>Standard&nbsp;<a href="#Bloom">Bloom</a>&nbsp;filter&nbsp;class<br>
&nbsp;<br>
Implements&nbsp;a&nbsp;standard&nbsp;<a href="#Bloom">Bloom</a>&nbsp;filter.<br>
m&nbsp;cells&nbsp;with&nbsp;True&nbsp;/&nbsp;False.<br>
Child&nbsp;of&nbsp;bloom().<br>
Members:<br>
<a href="#Bloom">Bloom</a>.*&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;inherited&nbsp;from&nbsp;<a href="#Bloom">Bloom</a>&nbsp;class<br>
_bf&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;the&nbsp;actual&nbsp;bloom&nbsp;filter,&nbsp;implemented&nbsp;as&nbsp;[&nbsp;bool&nbsp;]<br>&nbsp;</tt></td></tr>
<tr><td>&nbsp;</td>
<td width="100%">Methods defined here:<br>
<dl><dt><a name="BloomFilter-__init__"><strong>__init__</strong></a>(self, n, c, linear<font color="#909090">=True</font>, k<font color="#909090">=0</font>)</dt><dd><tt>Instatiate&nbsp;a&nbsp;<a href="#Bloom">Bloom</a>&nbsp;filter&nbsp;object.<br>
&nbsp;<br>
@n&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;number&nbsp;of&nbsp;elements&nbsp;to&nbsp;store<br>
@c&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;number&nbsp;of&nbsp;reserved&nbsp;cells&nbsp;per&nbsp;element<br>
@linear&nbsp;--&nbsp;&nbsp;True&nbsp;if&nbsp;size&nbsp;is&nbsp;computed&nbsp;linear,&nbsp;False&nbsp;if&nbsp;to&nbsp;power&nbsp;2<br>
@k&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;Number&nbsp;of&nbsp;hash&nbsp;functions,&nbsp;if&nbsp;0,&nbsp;optimum&nbsp;is&nbsp;computed</tt></dd></dl>

<dl><dt><a name="BloomFilter-__repr__"><strong>__repr__</strong></a>(self)</dt><dd><tt><a href="#BloomFilter-__repr__">__repr__</a>()&nbsp;-&gt;&nbsp;string</tt></dd></dl>

<dl><dt><a name="BloomFilter-clear"><strong>clear</strong></a>(self, *indexes)</dt><dd><tt><a href="#BloomFilter-clear">clear</a>(*indexes)&nbsp;--&nbsp;clear&nbsp;bits&nbsp;at&nbsp;positions&nbsp;in&nbsp;[indexes]</tt></dd></dl>

<dl><dt><a name="BloomFilter-dec"><strong>dec</strong></a>(self, *indexes)</dt><dd><tt><a href="#BloomFilter-dec">dec</a>(*indexes)&nbsp;--&nbsp;same&nbsp;as&nbsp;<a href="#BloomFilter-clear">clear</a>([indexes])</tt></dd></dl>

<dl><dt><a name="BloomFilter-get"><strong>get</strong></a>(self, *indexes)</dt><dd><tt><a href="#BloomFilter-get">get</a>(*indexes)&nbsp;-&gt;&nbsp;[bool&nbsp;for&nbsp;i&nbsp;in&nbsp;indexes]</tt></dd></dl>

<dl><dt><a name="BloomFilter-inc"><strong>inc</strong></a>(self, *indexes)</dt><dd><tt><a href="#BloomFilter-inc">inc</a>(*indexes)&nbsp;--&nbsp;same&nbsp;as&nbsp;<a href="#BloomFilter-set">set</a>([indexes])</tt></dd></dl>

<dl><dt><a name="BloomFilter-set"><strong>set</strong></a>(self, *indexes)</dt><dd><tt><a href="#BloomFilter-set">set</a>(*indexes)&nbsp;--&nbsp;set&nbsp;bits&nbsp;at&nbsp;positions&nbsp;in&nbsp;[indexes]</tt></dd></dl>

<hr>
Methods inherited from <a href="bloom.html#Bloom">Bloom</a>:<br>
<dl><dt><a name="BloomFilter-__len__"><strong>__len__</strong></a>(self)</dt><dd><tt><a href="#BloomFilter-__len__">__len__</a>()&nbsp;-&gt;&nbsp;self.<strong>_m</strong></tt></dd></dl>

<dl><dt><a name="BloomFilter-expecteddist"><strong>expecteddist</strong></a>(self, upper)</dt><dd><tt><a href="#BloomFilter-expecteddist">expecteddist</a>(upper)&nbsp;-&gt;&nbsp;[int]<br>
&nbsp;<br>
the&nbsp;expected&nbsp;distribution&nbsp;of&nbsp;counter&nbsp;values&nbsp;or&nbsp;insertions</tt></dd></dl>

<dl><dt><a name="BloomFilter-p_0"><strong>p_0</strong></a>(self)</dt><dd><tt><a href="#BloomFilter-p_0">p_0</a>()&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;any&nbsp;cell&nbsp;has&nbsp;0&nbsp;insertions</tt></dd></dl>

<dl><dt><a name="BloomFilter-p_countervalue"><strong>p_countervalue</strong></a>(self, i, j)</dt><dd><tt><a href="#BloomFilter-p_countervalue">p_countervalue</a>(i,j)&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;a&nbsp;counter&nbsp;in&nbsp;a&nbsp;set&nbsp;of&nbsp;j&nbsp;non-empty&nbsp;buckets&nbsp;is&nbsp;j<br>
p(i,j)&nbsp;in&nbsp;fht&nbsp;paper</tt></dd></dl>

<dl><dt><a name="BloomFilter-p_distinct"><strong>p_distinct</strong></a>(self, j, r)</dt><dd><tt>p_distinct&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;r&nbsp;hashes&nbsp;produce&nbsp;j&nbsp;distinct&nbsp;values</tt></dd></dl>

<dl><dt><a name="BloomFilter-p_fp"><strong>p_fp</strong></a>(self)</dt><dd><tt><a href="#BloomFilter-p_fp">p_fp</a>()&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
false&nbsp;positive&nbsp;probability</tt></dd></dl>

<dl><dt><a name="BloomFilter-p_i"><strong>p_i</strong></a>(self, i)</dt><dd><tt><a href="#BloomFilter-p_i">p_i</a>(i)&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;any&nbsp;cell&nbsp;has&nbsp;i&nbsp;insertions</tt></dd></dl>

<dl><dt><a name="BloomFilter-p_linkedlist"><strong>p_linkedlist</strong></a>(self, s)</dt><dd><tt><a href="#BloomFilter-p_linkedlist">p_linkedlist</a>(s)&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;the&nbsp;smallest&nbsp;value&nbsp;for&nbsp;any&nbsp;k'&lt;=&nbsp;k&nbsp;chosen<br>
cells&nbsp;has&nbsp;value&nbsp;s</tt></dd></dl>

<dl><dt><a name="BloomFilter-p_smallest"><strong>p_smallest</strong></a>(self, r, s, j)</dt><dd><tt><a href="#BloomFilter-p_smallest">p_smallest</a>(r,s,j)&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;smallest&nbsp;counter&nbsp;in&nbsp;any&nbsp;r&nbsp;of&nbsp;j&nbsp;buckets&nbsp;is&nbsp;s<br>
q(r,s,j)&nbsp;in&nbsp;fht&nbsp;paper</tt></dd></dl>

<dl><dt><a name="BloomFilter-size"><strong>size</strong></a>(self)</dt><dd><tt><a href="#BloomFilter-size">size</a>()&nbsp;-&gt;&nbsp;self.<strong>_m</strong>&nbsp;--&nbsp;same&nbsp;as&nbsp;len(bloom)</tt></dd></dl>

</td></tr></table> <p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#ffc8d8">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#000000" face="helvetica, arial"><a name="CountingBloomFilter">class <strong>CountingBloomFilter</strong></a>(<a href="bloom.html#Bloom">Bloom</a>)</font></td></tr>
    
<tr bgcolor="#ffc8d8"><td rowspan=2><tt>&nbsp;&nbsp;&nbsp;</tt></td>
<td colspan=2><tt>Implements&nbsp;a&nbsp;counting&nbsp;<a href="#Bloom">Bloom</a>&nbsp;filter<br>
&nbsp;<br>
Uses&nbsp;a&nbsp;sequence&nbsp;of&nbsp;ints&nbsp;as&nbsp;counters&nbsp;instead&nbsp;of&nbsp;bools.<br>
No&nbsp;bit&nbsp;tricks&nbsp;to&nbsp;actually&nbsp;use&nbsp;a&nbsp;certain&nbsp;amount&nbsp;of&nbsp;bits.<br>
Memory&nbsp;management&nbsp;left&nbsp;to&nbsp;python&nbsp;engine.<br>
Members:<br>
<a href="#Bloom">Bloom</a>.*&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;inherited&nbsp;from&nbsp;<a href="#Bloom">Bloom</a>&nbsp;class<br>
_bf&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;the&nbsp;counter&nbsp;sequence,&nbsp;implemented&nbsp;as&nbsp;[&nbsp;int&nbsp;]<br>&nbsp;</tt></td></tr>
<tr><td>&nbsp;</td>
<td width="100%">Methods defined here:<br>
<dl><dt><a name="CountingBloomFilter-__init__"><strong>__init__</strong></a>(self, n, c, linear<font color="#909090">=True</font>, k<font color="#909090">=0</font>)</dt></dl>

<dl><dt><a name="CountingBloomFilter-__repr__"><strong>__repr__</strong></a>(self)</dt><dd><tt><a href="#CountingBloomFilter-__repr__">__repr__</a>()&nbsp;-&gt;&nbsp;string</tt></dd></dl>

<dl><dt><a name="CountingBloomFilter-clear"><strong>clear</strong></a>(self, *indexes)</dt><dd><tt><a href="#CountingBloomFilter-clear">clear</a>(*indexes)&nbsp;--&nbsp;same&nbsp;as&nbsp;<a href="#CountingBloomFilter-dec">dec</a>([indexes])</tt></dd></dl>

<dl><dt><a name="CountingBloomFilter-dec"><strong>dec</strong></a>(self, *indexes)</dt><dd><tt><a href="#CountingBloomFilter-dec">dec</a>(*indexes)&nbsp;--&nbsp;decrement&nbsp;counters&nbsp;at&nbsp;positions&nbsp;in&nbsp;[indexes]</tt></dd></dl>

<dl><dt><a name="CountingBloomFilter-distribution"><strong>distribution</strong></a>(self)</dt><dd><tt><a href="#CountingBloomFilter-distribution">distribution</a>()&nbsp;-&gt;&nbsp;{&nbsp;value&nbsp;:&nbsp;frequency&nbsp;}<br>
&nbsp;<br>
Calculate&nbsp;a&nbsp;histogram&nbsp;of&nbsp;all&nbsp;counter&nbsp;values.<br>
Basically&nbsp;a&nbsp;wrapper&nbsp;for&nbsp;compressed&nbsp;cbfs,&nbsp;where<br>
distribution&nbsp;must&nbsp;be&nbsp;calculated&nbsp;individually.</tt></dd></dl>

<dl><dt><a name="CountingBloomFilter-get"><strong>get</strong></a>(self, *indexes)</dt><dd><tt><a href="#CountingBloomFilter-get">get</a>(*indexes)&nbsp;-&gt;&nbsp;[int&nbsp;for&nbsp;i&nbsp;in&nbsp;indexes]</tt></dd></dl>

<dl><dt><a name="CountingBloomFilter-inc"><strong>inc</strong></a>(self, *indexes)</dt><dd><tt><a href="#CountingBloomFilter-inc">inc</a>(*indexes)&nbsp;--&nbsp;increment&nbsp;counters&nbsp;at&nbsp;positions&nbsp;in&nbsp;[indexes]</tt></dd></dl>

<dl><dt><a name="CountingBloomFilter-maxcounter"><strong>maxcounter</strong></a>(self)</dt><dd><tt><a href="#CountingBloomFilter-maxcounter">maxcounter</a>()&nbsp;-&gt;&nbsp;max([bf])<br>
&nbsp;<br>
Calculate&nbsp;the&nbsp;maximum&nbsp;counter&nbsp;value.<br>
Basically&nbsp;a&nbsp;wrapper&nbsp;function&nbsp;for&nbsp;compressed&nbsp;cbfs</tt></dd></dl>

<dl><dt><a name="CountingBloomFilter-set"><strong>set</strong></a>(self, *indexes)</dt><dd><tt><a href="#CountingBloomFilter-set">set</a>(*indexes)&nbsp;--&nbsp;same&nbsp;as&nbsp;<a href="#CountingBloomFilter-inc">inc</a>([indexes])</tt></dd></dl>

<dl><dt><a name="CountingBloomFilter-size"><strong>size</strong></a>(self, cwidth<font color="#909090">=0</font>)</dt><dd><tt><a href="#CountingBloomFilter-size">size</a>(cwidth)&nbsp;-&gt;&nbsp;m&nbsp;*&nbsp;cwidth&nbsp;if&nbsp;cwidth&nbsp;&gt;&nbsp;0&nbsp;else&nbsp;m&nbsp;*&nbsp;log(max(bf,2))<br>
&nbsp;<br>
Calculates&nbsp;the&nbsp;number&nbsp;of&nbsp;bits&nbsp;needed&nbsp;for&nbsp;the&nbsp;counting&nbsp;<a href="#Bloom">Bloom</a>&nbsp;filter.<br>
Uses&nbsp;cwidth&nbsp;as&nbsp;counter&nbsp;width,&nbsp;ie,&nbsp;number&nbsp;of&nbsp;bits&nbsp;per&nbsp;counter.<br>
If&nbsp;cwidth&nbsp;==&nbsp;0,&nbsp;the&nbsp;counter&nbsp;width&nbsp;is&nbsp;calculated&nbsp;by&nbsp;evaluating<br>
the&nbsp;maximum&nbsp;counter&nbsp;value&nbsp;in&nbsp;the&nbsp;filter.</tt></dd></dl>

<hr>
Methods inherited from <a href="bloom.html#Bloom">Bloom</a>:<br>
<dl><dt><a name="CountingBloomFilter-__len__"><strong>__len__</strong></a>(self)</dt><dd><tt><a href="#CountingBloomFilter-__len__">__len__</a>()&nbsp;-&gt;&nbsp;self.<strong>_m</strong></tt></dd></dl>

<dl><dt><a name="CountingBloomFilter-expecteddist"><strong>expecteddist</strong></a>(self, upper)</dt><dd><tt><a href="#CountingBloomFilter-expecteddist">expecteddist</a>(upper)&nbsp;-&gt;&nbsp;[int]<br>
&nbsp;<br>
the&nbsp;expected&nbsp;distribution&nbsp;of&nbsp;counter&nbsp;values&nbsp;or&nbsp;insertions</tt></dd></dl>

<dl><dt><a name="CountingBloomFilter-p_0"><strong>p_0</strong></a>(self)</dt><dd><tt><a href="#CountingBloomFilter-p_0">p_0</a>()&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;any&nbsp;cell&nbsp;has&nbsp;0&nbsp;insertions</tt></dd></dl>

<dl><dt><a name="CountingBloomFilter-p_countervalue"><strong>p_countervalue</strong></a>(self, i, j)</dt><dd><tt><a href="#CountingBloomFilter-p_countervalue">p_countervalue</a>(i,j)&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;a&nbsp;counter&nbsp;in&nbsp;a&nbsp;set&nbsp;of&nbsp;j&nbsp;non-empty&nbsp;buckets&nbsp;is&nbsp;j<br>
p(i,j)&nbsp;in&nbsp;fht&nbsp;paper</tt></dd></dl>

<dl><dt><a name="CountingBloomFilter-p_distinct"><strong>p_distinct</strong></a>(self, j, r)</dt><dd><tt>p_distinct&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;r&nbsp;hashes&nbsp;produce&nbsp;j&nbsp;distinct&nbsp;values</tt></dd></dl>

<dl><dt><a name="CountingBloomFilter-p_fp"><strong>p_fp</strong></a>(self)</dt><dd><tt><a href="#CountingBloomFilter-p_fp">p_fp</a>()&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
false&nbsp;positive&nbsp;probability</tt></dd></dl>

<dl><dt><a name="CountingBloomFilter-p_i"><strong>p_i</strong></a>(self, i)</dt><dd><tt><a href="#CountingBloomFilter-p_i">p_i</a>(i)&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;any&nbsp;cell&nbsp;has&nbsp;i&nbsp;insertions</tt></dd></dl>

<dl><dt><a name="CountingBloomFilter-p_linkedlist"><strong>p_linkedlist</strong></a>(self, s)</dt><dd><tt><a href="#CountingBloomFilter-p_linkedlist">p_linkedlist</a>(s)&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;the&nbsp;smallest&nbsp;value&nbsp;for&nbsp;any&nbsp;k'&lt;=&nbsp;k&nbsp;chosen<br>
cells&nbsp;has&nbsp;value&nbsp;s</tt></dd></dl>

<dl><dt><a name="CountingBloomFilter-p_smallest"><strong>p_smallest</strong></a>(self, r, s, j)</dt><dd><tt><a href="#CountingBloomFilter-p_smallest">p_smallest</a>(r,s,j)&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;smallest&nbsp;counter&nbsp;in&nbsp;any&nbsp;r&nbsp;of&nbsp;j&nbsp;buckets&nbsp;is&nbsp;s<br>
q(r,s,j)&nbsp;in&nbsp;fht&nbsp;paper</tt></dd></dl>

</td></tr></table> <p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#ffc8d8">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#000000" face="helvetica, arial"><a name="HuffmanCountingBloomFilter">class <strong>HuffmanCountingBloomFilter</strong></a>(<a href="bloom.html#Bloom">Bloom</a>)</font></td></tr>
    
<tr bgcolor="#ffc8d8"><td rowspan=2><tt>&nbsp;&nbsp;&nbsp;</tt></td>
<td colspan=2><tt>Implements&nbsp;a&nbsp;Huffman&nbsp;compressed&nbsp;counting&nbsp;<a href="#Bloom">Bloom</a>&nbsp;filter<br>
&nbsp;<br>
The&nbsp;Huffman&nbsp;compressed&nbsp;counting&nbsp;<a href="#Bloom">Bloom</a>&nbsp;filter&nbsp;uses&nbsp;Huffman<br>
compression&nbsp;to&nbsp;encode&nbsp;the&nbsp;counter&nbsp;values.&nbsp;For&nbsp;easy&nbsp;indexing<br>
a&nbsp;fixed&nbsp;number&nbsp;of&nbsp;counters&nbsp;is&nbsp;compressed&nbsp;into&nbsp;one&nbsp;word<br>
of&nbsp;fixed&nbsp;size.<br>
Members:<br>
<a href="#Bloom">Bloom</a>.*&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;inherited&nbsp;from&nbsp;<a href="#Bloom">Bloom</a><br>
_huff&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Huffman&nbsp;compressor<br>
_wsize&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;word&nbsp;size<br>
_cmax&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;maximum&nbsp;counter&nbsp;value<br>
_rate&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;compression&nbsp;rate<br>
_overmax&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;counter&nbsp;values&nbsp;that&nbsp;exceed&nbsp;_cmax&nbsp;{&nbsp;index&nbsp;:&nbsp;value&nbsp;}<br>
_bf&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;the&nbsp;compressed&nbsp;counters<br>&nbsp;</tt></td></tr>
<tr><td>&nbsp;</td>
<td width="100%">Methods defined here:<br>
<dl><dt><a name="HuffmanCountingBloomFilter-__init__"><strong>__init__</strong></a>(self, cbf, wsize, cmax, rate<font color="#909090">=0</font>)</dt><dd><tt>Instantiate&nbsp;a&nbsp;Huffman&nbsp;compressed&nbsp;counting&nbsp;<a href="#Bloom">Bloom</a>&nbsp;filter<br>
&nbsp;<br>
cbf&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;an&nbsp;uncompressed&nbsp;counting&nbsp;<a href="#Bloom">Bloom</a>&nbsp;filter<br>
wsize&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;word&nbsp;size&nbsp;in&nbsp;bits<br>
cmax&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;maximum&nbsp;allowed&nbsp;counter&nbsp;value<br>
rate&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;compression&nbsp;rate,&nbsp;if&nbsp;0,&nbsp;it&nbsp;is&nbsp;calculated&nbsp;using&nbsp;soft&nbsp;compression</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-__repr__"><strong>__repr__</strong></a>(self)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-__repr__">__repr__</a>()&nbsp;-&gt;&nbsp;string</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-clear"><strong>clear</strong></a>(self, *indexes)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-clear">clear</a>(*indexes)&nbsp;--&nbsp;same&nbsp;as&nbsp;<a href="#HuffmanCountingBloomFilter-dec">dec</a>([indexes])</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-dec"><strong>dec</strong></a>(self, *indexes)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-dec">dec</a>(*indexes)&nbsp;--&nbsp;decrement&nbsp;counters&nbsp;at&nbsp;positions&nbsp;in&nbsp;[indexes]</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-distribution"><strong>distribution</strong></a>(self)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-distribution">distribution</a>()&nbsp;-&gt;&nbsp;{&nbsp;value&nbsp;:&nbsp;frequency&nbsp;}</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-get"><strong>get</strong></a>(self, *indexes)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-get">get</a>(*indexes)&nbsp;-&gt;&nbsp;[int&nbsp;for&nbsp;i&nbsp;in&nbsp;indexes]</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-inc"><strong>inc</strong></a>(self, *indexes)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-inc">inc</a>(*indexes)&nbsp;--&nbsp;increment&nbsp;counters&nbsp;at&nbsp;positions&nbsp;in&nbsp;[indexes]</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-maxcounter"><strong>maxcounter</strong></a>(self)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-maxcounter">maxcounter</a>()&nbsp;-&gt;&nbsp;max([bf])<br>
&nbsp;<br>
Calculate&nbsp;the&nbsp;maximum&nbsp;counter&nbsp;value.<br>
Basically&nbsp;a&nbsp;wrapper&nbsp;function&nbsp;for&nbsp;compressed&nbsp;cbfs</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-overflows"><strong>overflows</strong></a>(self)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-overflows">overflows</a>()&nbsp;-&gt;&nbsp;int,&nbsp;return&nbsp;number&nbsp;of&nbsp;counter&nbsp;overflows</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-psize"><strong>psize</strong></a>(self)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-psize">psize</a>()&nbsp;-&gt;&nbsp;filter&nbsp;size&nbsp;if&nbsp;compressed&nbsp;using&nbsp;word&nbsp;packing</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-set"><strong>set</strong></a>(self, *indexes)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-set">set</a>(*indexes)&nbsp;--&nbsp;same&nbsp;as&nbsp;<a href="#HuffmanCountingBloomFilter-inc">inc</a>([indexes])</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-size"><strong>size</strong></a>(self)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-size">size</a>()&nbsp;-&gt;&nbsp;compressed&nbsp;filter&nbsp;size,&nbsp;number&nbsp;of&nbsp;words&nbsp;*&nbsp;word&nbsp;size</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-usize"><strong>usize</strong></a>(self, cwidth<font color="#909090">=0</font>)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-size">size</a>()&nbsp;-&gt;&nbsp;uncompressed&nbsp;filter&nbsp;size,&nbsp;by&nbsp;word</tt></dd></dl>

<hr>
Methods inherited from <a href="bloom.html#Bloom">Bloom</a>:<br>
<dl><dt><a name="HuffmanCountingBloomFilter-__len__"><strong>__len__</strong></a>(self)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-__len__">__len__</a>()&nbsp;-&gt;&nbsp;self.<strong>_m</strong></tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-expecteddist"><strong>expecteddist</strong></a>(self, upper)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-expecteddist">expecteddist</a>(upper)&nbsp;-&gt;&nbsp;[int]<br>
&nbsp;<br>
the&nbsp;expected&nbsp;distribution&nbsp;of&nbsp;counter&nbsp;values&nbsp;or&nbsp;insertions</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-p_0"><strong>p_0</strong></a>(self)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-p_0">p_0</a>()&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;any&nbsp;cell&nbsp;has&nbsp;0&nbsp;insertions</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-p_countervalue"><strong>p_countervalue</strong></a>(self, i, j)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-p_countervalue">p_countervalue</a>(i,j)&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;a&nbsp;counter&nbsp;in&nbsp;a&nbsp;set&nbsp;of&nbsp;j&nbsp;non-empty&nbsp;buckets&nbsp;is&nbsp;j<br>
p(i,j)&nbsp;in&nbsp;fht&nbsp;paper</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-p_distinct"><strong>p_distinct</strong></a>(self, j, r)</dt><dd><tt>p_distinct&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;r&nbsp;hashes&nbsp;produce&nbsp;j&nbsp;distinct&nbsp;values</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-p_fp"><strong>p_fp</strong></a>(self)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-p_fp">p_fp</a>()&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
false&nbsp;positive&nbsp;probability</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-p_i"><strong>p_i</strong></a>(self, i)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-p_i">p_i</a>(i)&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;any&nbsp;cell&nbsp;has&nbsp;i&nbsp;insertions</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-p_linkedlist"><strong>p_linkedlist</strong></a>(self, s)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-p_linkedlist">p_linkedlist</a>(s)&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;the&nbsp;smallest&nbsp;value&nbsp;for&nbsp;any&nbsp;k'&lt;=&nbsp;k&nbsp;chosen<br>
cells&nbsp;has&nbsp;value&nbsp;s</tt></dd></dl>

<dl><dt><a name="HuffmanCountingBloomFilter-p_smallest"><strong>p_smallest</strong></a>(self, r, s, j)</dt><dd><tt><a href="#HuffmanCountingBloomFilter-p_smallest">p_smallest</a>(r,s,j)&nbsp;-&gt;&nbsp;float<br>
&nbsp;<br>
probability&nbsp;that&nbsp;smallest&nbsp;counter&nbsp;in&nbsp;any&nbsp;r&nbsp;of&nbsp;j&nbsp;buckets&nbsp;is&nbsp;s<br>
q(r,s,j)&nbsp;in&nbsp;fht&nbsp;paper</tt></dd></dl>

</td></tr></table></td></tr></table><p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#eeaa77">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial"><big><strong>Functions</strong></big></font></td></tr>
    
<tr><td bgcolor="#eeaa77"><tt>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</tt></td><td>&nbsp;</td>
<td width="100%"><dl><dt><a name="-kbf"><strong>kbf</strong></a>(n, m)</dt><dd><tt><a href="#-kbf">kbf</a>(n,m)&nbsp;-&gt;&nbsp;m/n&nbsp;ln&nbsp;2</tt></dd></dl>
 <dl><dt><a name="-mbf"><strong>mbf</strong></a>(c, n)</dt><dd><tt><a href="#-mbf">mbf</a>(c,n)&nbsp;-&gt;&nbsp;c*n</tt></dd></dl>
 <dl><dt><a name="-mfht"><strong>mfht</strong></a>(c, n)</dt><dd><tt><a href="#-mfht">mfht</a>(c,n)&nbsp;-&gt;&nbsp;2**(log(cn,2))</tt></dd></dl>
</td></tr></table><p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#55aa55">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial"><big><strong>Data</strong></big></font></td></tr>
    
<tr><td bgcolor="#55aa55"><tt>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</tt></td><td>&nbsp;</td>
<td width="100%"><strong>__all__</strong> = ['Bloom', 'BloomFilter', 'CountingBloomFilter', 'HuffmanCountingBloomFilter', 'mbf', 'mfht', 'kbf']</td></tr></table>
</body></html>